// Cross-Browser Rich Text Editor
// http://www.kevinroth.com/rte/demo.htm
// Written by Kevin Roth (kevin@NOSPAMkevinroth.com - remove NOSPAM)
// Visit the support forums at http://www.kevinroth.com/forums/index.php?c=2

//init variables
var isRichText = false;
var rng;
var currentRTE;
var allRTEs = "";

var isIE;
var isGecko;
var isSafari;
var isKonqueror;

var imagesPath;
var includesPath;
var cssFile;
function AG_browser()
	{
		this.browser = navigator;
		this.userAgent = this.browser.userAgent.toLowerCase();
	}
AG_browser.prototype.isIe = function()
	{
		return(!this.isOpera() && !this.isFirefox() &&this.userAgent.indexOf('msie')>=0);
	}
AG_browser.prototype.isOpera = function()
	{
		return(this.userAgent.indexOf('opera')>=0);
	}
AG_browser.prototype.isFirefox = function()
	{
		return(this.userAgent.indexOf('firefox')>=0);
	}
var b = new AG_browser();

function initRTE(imgPath, incPath, css) {
	//set browser vars
	var ua = navigator.userAgent.toLowerCase();
	isIE = ((ua.indexOf("msie") != -1) && (ua.indexOf("opera") == -1) && (ua.indexOf("webtv") == -1));
	isGecko = (ua.indexOf("gecko") != -1);
	isSafari = (ua.indexOf("safari") != -1);
	isKonqueror = (ua.indexOf("konqueror") != -1);

	//check to see if designMode mode is available
	if (document.getElementById && document.designMode && !isKonqueror) {
		isRichText = true;
	}

	if (isIE) {
		document.onmouseover = raiseButton;
		document.onmouseout  = normalButton;
		document.onmousedown = lowerButton;
		document.onmouseup   = raiseButton;
	}

	//set paths vars
	imagesPath = imgPath;
	includesPath = incPath;
	cssFile = css;

	//if (isRichText) document.writeln('<style type="text/css">@import "' + includesPath + 'css/rte.css";</style>');

	//for testing standard textarea, uncomment the following line
	//isRichText = false;
}

function writeRichText(rte, html, width, height, buttons, readOnly) {
	if (isRichText) {
		if (allRTEs.length > 0) allRTEs += ";";
		allRTEs += rte;

		if (readOnly) buttons = false;

		//adjust minimum table widths
		if (isIE) {
			if (buttons && (width < 540)) width = "100%";
			var tablewidth = "100%";
		} else {
			if (buttons && (width < 540)) width = "100%";
			var tablewidth = "100%";
		}

		document.writeln('<div class="rteDiv">');
		if (buttons == true) {
			document.writeln('<div class="clsRichTextLeft" id="Buttons1_' + rte + '" >');
			document.writeln('<div class="clsRichTextRight">');
			document.writeln('<table class="clsRichTextTbl" border="0" cellpadding="0" cellspacing="0" id="Buttons2_' + rte + '" width="' + tablewidth + '">');
			document.writeln('	<tr>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-bold.jpg" width="9" height="30" alt="' + EDITOR_LANG['Bold'] + '" title="' + EDITOR_LANG['Bold'] + '" onClick="rteCommand(\'' + rte + '\', \'bold\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-italics.jpg" width="9" height="30" alt="' + EDITOR_LANG['Italic'] + '" title="' + EDITOR_LANG['Italic'] + '" onClick="rteCommand(\'' + rte + '\', \'italic\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bgstrike.jpg" width="12" alt="' + EDITOR_LANG['Strikethrough'] + '" title="' + EDITOR_LANG['Strikethrough'] + '" onClick="rteCommand(\'' + rte + '\', \'strikethrough\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-subscript.jpg" width="10" alt="' + EDITOR_LANG['Subscript'] + '" title="' + EDITOR_LANG['Subscript'] + '" onClick="rteCommand(\'' + rte + '\', \'subscript\', \'\')"></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-superscript.jpg" width="10" alt="' + EDITOR_LANG['Superscript'] + '" title="' + EDITOR_LANG['Superscript'] + '" onClick="rteCommand(\'' + rte + '\', \'superscript\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-bullet.jpg" width="16" alt="' + EDITOR_LANG['Unordered_List'] + '" title="' + EDITOR_LANG['Unordered_List'] + '" onClick="rteCommand(\'' + rte + '\', \'insertunorderedlist\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-number.jpg" width="16" alt="' + EDITOR_LANG['Ordered_List'] + '" title="' + EDITOR_LANG['Ordered_List'] + '" onClick="rteCommand(\'' + rte + '\', \'insertorderedlist\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-justifyleft.jpg" width="14" alt="' + EDITOR_LANG['Align_Left'] + '" title="' + EDITOR_LANG['Align_Left'] + '" onClick="rteCommand(\'' + rte + '\', \'justifyleft\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-justifycenter.jpg" width="14" alt="' + EDITOR_LANG['Center'] + '" title="' + EDITOR_LANG['Center'] + '" onClick="rteCommand(\'' + rte + '\', \'justifycenter\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-justifyright.jpg" width="14" height="30" alt="' + EDITOR_LANG['Align_Right'] + '" title="' + EDITOR_LANG['Align_Right'] + '" onClick="rteCommand(\'' + rte + '\', \'justifyright\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-justify.jpg" width="14" height="30" alt="' + EDITOR_LANG['Justify_Full'] + '" title="' + EDITOR_LANG['Justify_Full'] + '" onclick="rteCommand(\'' + rte + '\', \'justifyfull\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-horizontalline.jpg" width="15" height="30" alt="' + EDITOR_LANG['Horizontal_Rule'] + '" title="' + EDITOR_LANG['Horizontal_Rule'] + '" onClick="rteCommand(\'' + rte + '\', \'inserthorizontalrule\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-leftalign.jpg" width="17" height="30" alt="' + EDITOR_LANG['Outdent'] + '" title="' + EDITOR_LANG['Outdent'] + '" onClick="rteCommand(\'' + rte + '\', \'outdent\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-rightalign.jpg" width="16" height="30" alt="' + EDITOR_LANG['Indent'] + '" title="' + EDITOR_LANG['Indent'] + '" onClick="rteCommand(\'' + rte + '\', \'indent\', \'\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" /></td>');
			document.writeln('		<td><div id="forecolor_' + rte + '"><img src="' + imagesPath + 'bg-fontcolor.jpg" width="15" height="30" alt="' + EDITOR_LANG['Text_Color'] + '" title="' + EDITOR_LANG['Text_Color'] + '" onClick="dlgColorPalette(\'' + rte + '\', \'forecolor\', \'\')" /></div></td>');
			document.writeln('		<td><div id="hilitecolor_' + rte + '"><img src="' + imagesPath + 'bg-highlightcolor.jpg" width="18" height="30" alt="' + EDITOR_LANG['Background_Color'] + '" title="' + EDITOR_LANG['Background_Color'] + '" onClick="dlgColorPalette(\'' + rte + '\', \'hilitecolor\', \'\')" /></div></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-separator.jpg" style="display:block" width="2" height="30" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-insertlink.jpg" width="18" height="30" alt="' + EDITOR_LANG['Insert_Link'] + '" title="' + EDITOR_LANG['Insert_Link'] + '" onClick="insertLink(\'' + rte + '\')" /></td>');
			document.writeln('		<td><img src="' + imagesPath + 'bg-imagegallery.jpg" width="18" height="30" alt="' + EDITOR_LANG['Add_Image'] + '" title="' + EDITOR_LANG['Add_Image'] + '" onClick="addImage(\'' + rte + '\')" /></td>');
			document.writeln('	</tr>');
			document.writeln('</table>');
			document.writeln('</div>');
			document.writeln('</div>');
		}
		 document.writeln('    <div class="clsRichText">');
		  <!--rounded corners-->
   document.writeln(' <div class="lbrichtext">');
     document.writeln('  <div class="rbrichtext">');
        document.writeln(' <div class="bbrichtext">');
        document.writeln('   <div class="blcrichtext">');
          document.writeln('   <div class="brcrichtext">');
           document.writeln('    <div class="tbrichtext">');
             document.writeln('    <div class="tlcrichtext">');
              document.writeln('     <div class="trcrichtext">');

		document.writeln('<table class="clsContentIframeTable"><tr><td><iframe class="clsContentIframe" id="' + rte + '" name="' + rte + '" width="' + width + '" height="' + height + 'px" src="' + includesPath + 'blank.htm"></iframe></td></tr></table>');
		           	document.writeln(' </div>');
                  document.writeln('  </div>');
                document.writeln(' </div>');
              document.writeln(' </div>');
           document.writeln('  </div>');
          document.writeln(' </div>');
       document.writeln('  </div>');
     document.writeln('  </div>');
    document.writeln(' </div>');
    <!--end of rounded corners-->
		if (!readOnly) document.writeln('<br /><input type="checkbox" class="clsCheckRadio" id="chkSrc' + rte + '" onclick="toggleHTMLSrc(\'' + rte + '\');" />&nbsp;'+EDITOR_LANG['view_source']);
		document.writeln('<iframe class="clsPaletteIframe" width="154" height="104" id="cp' + rte + '" src="'+palette_url+'" marginwidth="0" marginheight="0" scrolling="no"  style="visibility:hidden; position: absolute; border: 0; width: auto!important;"></iframe>');
		document.writeln('<input type="hidden" id="hdn' + rte + '" name="' + rte + '" value="" />');
		document.writeln('</div>');

		document.getElementById('hdn' + rte).value = html;
		enableDesignMode(rte, html, readOnly);
	} else {
		if (!readOnly) {
			document.writeln('<textarea name="' + rte + '" id="' + rte + '" style="width: ' + width + 'px; height: ' + height + 'px;">' + html + '</textarea>');
		} else {
			document.writeln('<textarea name="' + rte + '" id="' + rte + '" style="width: ' + width + 'px; height: ' + height + 'px;" readonly>' + html + '</textarea>');
		}
	}
}

function enableDesignMode(rte, html, readOnly) {
	var frameHtml = "<html id=\"" + rte + "\">\n";
	frameHtml += "<head>\n";
	//to reference your stylesheet, set href property below to your stylesheet path and uncomment
	if (cssFile.length > 0) {
		frameHtml += "<link media=\"all\" type=\"text/css\" href=\"" + cssFile + "\" rel=\"stylesheet\">\n";
	} else {
		frameHtml += "<style>\n";
		frameHtml += "body {\n";
		frameHtml += "	background: #FFFFFF;\n";
		frameHtml += "	margin: 0px;\n";
		frameHtml += "	padding: 0px;\n";
		frameHtml += "}\n";
		frameHtml += "</style>\n";
	}
	frameHtml += "</head>\n";
	frameHtml += "<body>\n";
	frameHtml += html + "\n";
	frameHtml += "</body>\n";
	frameHtml += "</html>";
	if (document.all) {
		var oRTE = frames[rte].document;
		oRTE.open();
		oRTE.write(frameHtml);
		oRTE.close();
		document.getElementById(rte).src = filenameNew;
		if (!readOnly) oRTE.designMode = "On";
	} else {
		try {
			if (!readOnly) document.getElementById(rte).contentDocument.designMode = "on";
			try {
				var oRTE = document.getElementById(rte).contentWindow.document;
				oRTE.open();
				frameHtml = document.getElementById(field_name).value;
				oRTE.write(frameHtml);
				oRTE.close();
				//document.getElementById(rte).src = filenameNew;
				if (isGecko && !readOnly) {
					//attach a keyboard handler for gecko browsers to make keyboard shortcuts work
					oRTE.addEventListener("keypress", kb_handler, true);
				}
			} catch (e) {
				alert("Error preloading content.");
			}
		} catch (e) {
			//gecko may take some time to enable design mode.
			//Keep looping until able to set.
			if (isGecko) {
				setTimeout("enableDesignMode('" + rte + "', '" + html + "', " + readOnly + ");", 10);
			} else {
				return false;
			}
		}
	}
}

function updateRTEs() {
	var vRTEs = allRTEs.split(";");
	for (var i = 0; i < vRTEs.length; i++) {
		updateRTE(vRTEs[i]);
	}
}

function updateRTE(rte) {
	if (!isRichText) return;

	//set message value
	var oHdnMessage = document.getElementById('hdn' + rte);
	var oRTE = document.getElementById(rte);
	var readOnly = false;

	//check for readOnly mode
	if (document.all) {
		if (frames[rte].document.designMode != "On") readOnly = true;
	} else {
		if (document.getElementById(rte).contentDocument.designMode != "on") readOnly = true;
	}

	if (isRichText && !readOnly) {
		//if viewing source, switch back to design view
		if (document.getElementById("chkSrc" + rte).checked) {
			document.getElementById("chkSrc" + rte).checked = false;
			toggleHTMLSrc(rte);
		}

		if (oHdnMessage.value == null) oHdnMessage.value = "";
		if (document.all) {
			oHdnMessage.value = frames[rte].document.body.innerHTML;
		} else {
			oHdnMessage.value = oRTE.contentWindow.document.body.innerHTML;
		}

		//if there is no content (other than formatting) set value to nothing
		if (stripHTML(oHdnMessage.value.replace("&nbsp;", " ")) == ""
			&& oHdnMessage.value.toLowerCase().search("<hr") == -1
			&& oHdnMessage.value.toLowerCase().search("<img") == -1) oHdnMessage.value = "";
		//fix for gecko
		if (escape(oHdnMessage.value) == "%3Cbr%3E%0D%0A%0D%0A%0D%0A") oHdnMessage.value = "";
	}
}

function rteCommand(rte, command, option) {
	//function to perform command
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
	} else {
		oRTE = document.getElementById(rte).contentWindow;
	}

	try {
		oRTE.focus();
	  	oRTE.document.execCommand(command, false, option);
		oRTE.focus();
	} catch (e) {
//		alert(e);
//		setTimeout("rteCommand('" + rte + "', '" + command + "', '" + option + "');", 10);
	}
}

function toggleHTMLSrc(rte) {
	//contributed by Bob Hutzel (thanks Bob!)
	var oRTE;
	if (document.all) {
		oRTE = frames[rte].document;
	} else {
		oRTE = document.getElementById(rte).contentWindow.document;
	}

	if (document.getElementById("chkSrc" + rte).checked) {
		showHideElement("Buttons1_" + rte, "hide");
		showHideElement("Buttons2_" + rte, "hide");
		if (document.all) {
			oRTE.body.innerText = oRTE.body.innerHTML;
		} else {
			var htmlSrc = oRTE.createTextNode(oRTE.body.innerHTML);
			oRTE.body.innerHTML = "";
			oRTE.body.appendChild(htmlSrc);
		}
	} else {
		showHideElement("Buttons1_" + rte, "show");
		showHideElement("Buttons2_" + rte, "show");
		if (document.all) {
			//fix for IE
			var output = escape(oRTE.body.innerText);
			output = output.replace("%3CP%3E%0D%0A%3CHR%3E", "%3CHR%3E");
			output = output.replace("%3CHR%3E%0D%0A%3C/P%3E", "%3CHR%3E");

			oRTE.body.innerHTML = unescape(output);
		} else {
			var htmlSrc = oRTE.body.ownerDocument.createRange();
			htmlSrc.selectNodeContents(oRTE.body);
			oRTE.body.innerHTML = htmlSrc.toString();
		}
	}
}

function dlgColorPalette(rte, command) {
	//function to display or hide color palettes
	setRange(rte);

	//get dialog position
	var oDialog = document.getElementById('cp' + rte);
	var buttonElement = document.getElementById(command + '_' + rte);

	//alert(getOffsetTop(buttonElement));
	//alert(getAbsoluteOffsetTopConfirmation(buttonElement));


	var iLeftPos = getAbsoluteOffsetLeftConfirmation(buttonElement) - 70;
	var iTopPos = getAbsoluteOffsetTopConfirmation(buttonElement) - 105;
	oDialog.style.left = (iLeftPos) + "px";
	oDialog.style.top = (iTopPos) + "px";

	if ((command == parent.command) && (rte == currentRTE)) {
		//if current command dialog is currently open, close it
		if (oDialog.style.visibility == "hidden") {
			showHideElement(oDialog, 'show');
		} else {
			showHideElement(oDialog, 'hide');
		}
	} else {
		//if opening a new dialog, close all others
		var vRTEs = allRTEs.split(";");
		for (var i = 0; i < vRTEs.length; i++) {
			showHideElement('cp' + vRTEs[i], 'hide');
		}
		showHideElement(oDialog, 'show');
	}

	//save current values
	parent.command = command;
	currentRTE = rte;
}

function dlgInsertTable(rte, command) {
	//function to open/close insert table dialog
	//save current values
	setRange(rte);
	parent.command = command;
	currentRTE = rte;
	var windowOptions = 'history=no,toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=no,resizable=no,width=360,height=200';
	window.open(includesPath + 'insert_table.htm', 'InsertTable', windowOptions);
}

function insertLink(rte) {
	//function to insert link
	var szURL = prompt("Enter a URL:", "");
	if(szURL==null)return;
	if(trim(szURL))
		{
			//szURL = szURL.replace('http://','');
			//szURL = szURL.replace('http:\\','');
			//szURL = 'http://'+szURL;
			try {
					rteCommand(rte, "CreateLink", szURL);
				}
			catch (e)
				{
				}
		}
	else
		{
				try
				{
					rteCommand(rte, "Unlink", null);
				}
			catch (e)
				{
				}
		}
}

function setColor(color) {
	//function to set color
	var rte = currentRTE;
	var parentCommand = parent.command;

	if (document.all) {
		//retrieve selected range
		var sel = frames[rte].document.selection;
		if (parentCommand == "hilitecolor") parentCommand = "backcolor";
		if (sel != null) {
			var newRng = sel.createRange();
			newRng = rng;
			newRng.select();
		}
	}

	rteCommand(rte, parentCommand, color);
	showHideElement('cp' + rte, "hide");
}

function addImage(rte) {
	//function to add image
	imagePath = prompt('Enter Image URL:', 'http://');
	if ((imagePath != null) && (imagePath != "")) {
		rteCommand(rte, 'InsertImage', imagePath);
	}
}

// Ernst de Moor: Fix the amount of digging parents up, in case the RTE editor itself is displayed in a div.
// KJR 11/12/2004 Changed to position palette based on parent div, so palette will always appear in proper location regardless of nested divs
function getOffsetTop(elm) {
	var mOffsetTop = elm.offsetTop;
	var mOffsetParent = elm.offsetParent;
	var parents_up = 2; //the positioning div is 2 elements up the tree

	while(parents_up > 0) {
		mOffsetTop += mOffsetParent.offsetTop;
		mOffsetParent = mOffsetParent.offsetParent;
		parents_up--;
	}

	return mOffsetTop;
}

// Ernst de Moor: Fix the amount of digging parents up, in case the RTE editor itself is displayed in a div.
// KJR 11/12/2004 Changed to position palette based on parent div, so palette will always appear in proper location regardless of nested divs
function getOffsetLeft(elm) {
	var mOffsetLeft = elm.offsetLeft;
	var mOffsetParent = elm.offsetParent;
	var parents_up = 2;

	while(parents_up > 0) {
		mOffsetLeft += mOffsetParent.offsetLeft;
		mOffsetParent = mOffsetParent.offsetParent;
		parents_up--;
	}

	return mOffsetLeft;
}

function selectFont(rte, selectname) {
	//function to handle font changes
	var idx = document.getElementById(selectname).selectedIndex;
	// First one is always a label
	if (idx != 0) {
		var selected = document.getElementById(selectname).options[idx].value;
		var cmd = selectname.replace('_' + rte, '');
		rteCommand(rte, cmd, selected);
		document.getElementById(selectname).selectedIndex = 0;
	}
}

function kb_handler(evt) {
	var rte = evt.target.id;

	//contributed by Anti Veeranna (thanks Anti!)
	if (evt.ctrlKey) {
		var key = String.fromCharCode(evt.charCode).toLowerCase();
		var cmd = '';
		switch (key) {
			case 'b': cmd = "bold"; break;
			case 'i': cmd = "italic"; break;
			case 'u': cmd = "underline"; break;
		};

		if (cmd) {
			rteCommand(rte, cmd, null);

			// stop the event bubble
			evt.preventDefault();
			evt.stopPropagation();
		}
 	}
}

function insertHTML(html) {
	//function to add HTML -- thanks dannyuk1982
	var rte = currentRTE;

	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
	} else {
		oRTE = document.getElementById(rte).contentWindow;
	}

	oRTE.focus();
	if (document.all) {
		oRTE.document.selection.createRange().pasteHTML(html);
	} else {
		oRTE.document.execCommand('insertHTML', false, html);
	}
}

function showHideElement(element, showHide) {
	//function to show or hide elements
	//element variable can be string or object
	if (document.getElementById(element)) {
		element = document.getElementById(element);
	}

	if (showHide == "show") {
		element.style.visibility = "visible";
	} else if (showHide == "hide") {
		element.style.visibility = "hidden";
	}
}

function setRange(rte) {
	//function to store range of current selection
	var oRTE;
	if (document.all) {
		oRTE = frames[rte];
		var selection = oRTE.document.selection;
		if (selection != null) rng = selection.createRange();
	} else {
		oRTE = document.getElementById(rte).contentWindow;
		var selection = oRTE.getSelection();
		rng = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	}
}

function stripHTML(oldString) {
	//function to strip all html
	var newString = oldString.replace(/(<([^>]+)>)/ig,"");

	//replace carriage returns and line feeds
   newString = newString.replace(/\r\n/g," ");
   newString = newString.replace(/\n/g," ");
   newString = newString.replace(/\r/g," ");

	//trim string
	newString = trim(newString);

	return newString;
}

function trim(inputString) {
   // Removes leading and trailing spaces from the passed string. Also removes
   // consecutive spaces and replaces it with one space. If something besides
   // a string is passed in (null, custom object, etc.) then return the input.
   if (typeof inputString != "string") return inputString;
   var retValue = inputString;
   var ch = retValue.substring(0, 1);

   while (ch == " ") { // Check for spaces at the beginning of the string
      retValue = retValue.substring(1, retValue.length);
      ch = retValue.substring(0, 1);
   }
   ch = retValue.substring(retValue.length - 1, retValue.length);

   while (ch == " ") { // Check for spaces at the end of the string
      retValue = retValue.substring(0, retValue.length - 1);
      ch = retValue.substring(retValue.length - 1, retValue.length);
   }

	// Note that there are two spaces in the string - look for multiple spaces within the string
   while (retValue.indexOf("  ") != -1) {
		// Again, there are two spaces in each of the strings
      retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ") + 1, retValue.length);
   }
   return retValue; // Return the trimmed string back to the user
}

//*****************
//IE-Only Functions
//*****************
function checkspell() {
	//function to perform spell check
	try {
		var tmpis = new ActiveXObject("ieSpell.ieSpellExtension");
		tmpis.CheckAllLinkedDocuments(document);
	}
	catch(exception) {
		if(exception.number==-2146827859) {
			if (confirm("ieSpell not detected.  Click Ok to go to download page."))
				window.open("http://www.iespell.com/download.php","DownLoad");
		} else {
			alert("Error Loading ieSpell: Exception " + exception.number);
		}
	}
}

function raiseButton(e) {
	//IE-Only Function
	var el = window.event.srcElement;

	className = el.className;
	if (className == 'rteImage' || className == 'rteImageLowered') {
		el.className = 'rteImageRaised';
	}
}

function normalButton(e) {
	//IE-Only Function
	var el = window.event.srcElement;

	className = el.className;
	if (className == 'rteImageRaised' || className == 'rteImageLowered') {
		el.className = 'rteImage';
	}
}

function lowerButton(e) {
	//IE-Only Function
	var el = window.event.srcElement;

	className = el.className;
	if (className == 'rteImage' || className == 'rteImageRaised') {
		el.className = 'rteImageLowered';
	}
}

var getHTMLSource = function()
	{
		var obj = document.getElementById('chkSrcrte1');
		if(obj.checked)
			obj.click();

		var rte =arguments[0];
		var form_name = arguments[1];
		var hidden_name = arguments[2];

		var oRTE;
		if (document.all)
			oRTE = frames[rte].document;
		else
			oRTE = document.getElementById(rte).contentWindow.document;

		var obj = eval('document.'+form_name+'.'+hidden_name);
		obj.value = oRTE.body.innerHTML
		//alert(obj.value);
	}
